unit WinForm;

interface

uses
  System.Drawing, System.Collections, System.ComponentModel,
  System.Windows.Forms, System.Data, System.Xml, ClsRSS;

type
  TWinForm = class(System.Windows.Forms.Form)
  {$REGION 'Designer Managed Code'}
  strict private
    /// <summary>
    /// Required designer variable.
    /// </summary>
    Components: System.ComponentModel.Container;
    btnSaveFeed: System.Windows.Forms.Button;
    btnLoadFeed: System.Windows.Forms.Button;
    lvRSS: System.Windows.Forms.ListView;
    Title: System.Windows.Forms.ColumnHeader;
    pubDate: System.Windows.Forms.ColumnHeader;
    btnAddItem: System.Windows.Forms.Button;
    btnDeleteItem: System.Windows.Forms.Button;
    /// <summary>
    /// Required method for Designer support - do not modify
    /// the contents of this method with the code editor.
    /// </summary>
    procedure InitializeComponent;
    procedure btnAddItem_Click(sender: System.Object; e: System.EventArgs);
    procedure btnDeleteItem_Click(sender: System.Object; e: System.EventArgs);
    procedure lvRSS_DoubleClick(sender: System.Object; e: System.EventArgs);
    procedure btnLoadFeed_Click(sender: System.Object; e: System.EventArgs);
    procedure btnSaveFeed_Click(sender: System.Object; e: System.EventArgs);
    procedure lvRSS_SelectedIndexChanged(sender: System.Object; e: System.EventArgs);
  {$ENDREGION}
  strict protected
    /// <summary>
    /// Clean up any resources being used.
    /// </summary>
    procedure Dispose(Disposing: Boolean); override;
  private
    procedure _RedrawListView;

  public
    rss : TRSS;
    constructor Create;
  end;

  [assembly: RuntimeRequiredAttribute(TypeOf(TWinForm))]

implementation

uses RSSItem, Global;

{$AUTOBOX ON}

{$REGION 'Windows Form Designer generated code'}
/// <summary>
/// Required method for Designer support -- do not modify
/// the contents of this method with the code editor.
/// </summary>
procedure TWinForm.InitializeComponent;
type
  TArrayOfSystem_Windows_Forms_ColumnHeader = array of System.Windows.Forms.ColumnHeader;
begin
  Self.btnSaveFeed := System.Windows.Forms.Button.Create;
  Self.btnLoadFeed := System.Windows.Forms.Button.Create;
  Self.lvRSS := System.Windows.Forms.ListView.Create;
  Self.Title := System.Windows.Forms.ColumnHeader.Create;
  Self.pubDate := System.Windows.Forms.ColumnHeader.Create;
  Self.btnAddItem := System.Windows.Forms.Button.Create;
  Self.btnDeleteItem := System.Windows.Forms.Button.Create;
  Self.SuspendLayout;
  // 
  // btnSaveFeed
  // 
  Self.btnSaveFeed.Location := System.Drawing.Point.Create(608, 56);
  Self.btnSaveFeed.Name := 'btnSaveFeed';
  Self.btnSaveFeed.Size := System.Drawing.Size.Create(64, 32);
  Self.btnSaveFeed.TabIndex := 0;
  Self.btnSaveFeed.Text := '&Save RSS feed';
  Include(Self.btnSaveFeed.Click, Self.btnSaveFeed_Click);
  // 
  // btnLoadFeed
  // 
  Self.btnLoadFeed.Location := System.Drawing.Point.Create(608, 8);
  Self.btnLoadFeed.Name := 'btnLoadFeed';
  Self.btnLoadFeed.Size := System.Drawing.Size.Create(64, 32);
  Self.btnLoadFeed.TabIndex := 1;
  Self.btnLoadFeed.Text := '&Load RSS feed';
  Include(Self.btnLoadFeed.Click, Self.btnLoadFeed_Click);
  // 
  // lvRSS
  // 
  Self.lvRSS.Columns.AddRange(TArrayOfSystem_Windows_Forms_ColumnHeader.Create(Self.Title, 
          Self.pubDate));
  Self.lvRSS.FullRowSelect := True;
  Self.lvRSS.Location := System.Drawing.Point.Create(8, 8);
  Self.lvRSS.MultiSelect := False;
  Self.lvRSS.Name := 'lvRSS';
  Self.lvRSS.Size := System.Drawing.Size.Create(592, 392);
  Self.lvRSS.TabIndex := 2;
  Self.lvRSS.View := System.Windows.Forms.View.Details;
  Include(Self.lvRSS.DoubleClick, Self.lvRSS_DoubleClick);
  Include(Self.lvRSS.SelectedIndexChanged, Self.lvRSS_SelectedIndexChanged);
  // 
  // Title
  // 
  Self.Title.Text := 'Title';
  Self.Title.Width := 234;
  // 
  // pubDate
  // 
  Self.pubDate.Text := 'Published Date';
  Self.pubDate.Width := 103;
  // 
  // btnAddItem
  // 
  Self.btnAddItem.Location := System.Drawing.Point.Create(608, 328);
  Self.btnAddItem.Name := 'btnAddItem';
  Self.btnAddItem.Size := System.Drawing.Size.Create(64, 32);
  Self.btnAddItem.TabIndex := 3;
  Self.btnAddItem.Text := '&Add Item';
  Include(Self.btnAddItem.Click, Self.btnAddItem_Click);
  // 
  // btnDeleteItem
  // 
  Self.btnDeleteItem.Location := System.Drawing.Point.Create(608, 368);
  Self.btnDeleteItem.Name := 'btnDeleteItem';
  Self.btnDeleteItem.Size := System.Drawing.Size.Create(64, 32);
  Self.btnDeleteItem.TabIndex := 4;
  Self.btnDeleteItem.Text := '&Delete Item';
  Include(Self.btnDeleteItem.Click, Self.btnDeleteItem_Click);
  // 
  // TWinForm
  // 
  Self.AutoScaleBaseSize := System.Drawing.Size.Create(5, 13);
  Self.ClientSize := System.Drawing.Size.Create(792, 454);
  Self.Controls.Add(Self.btnDeleteItem);
  Self.Controls.Add(Self.btnAddItem);
  Self.Controls.Add(Self.lvRSS);
  Self.Controls.Add(Self.btnLoadFeed);
  Self.Controls.Add(Self.btnSaveFeed);
  Self.Name := 'TWinForm';
  Self.StartPosition := System.Windows.Forms.FormStartPosition.CenterScreen;
  Self.Text := 'RSS Creation/Management';
  Self.ResumeLayout(False);
end;
{$ENDREGION}

procedure TWinForm.Dispose(Disposing: Boolean);
begin
  if Disposing then
  begin
    if Components <> nil then
      Components.Dispose();
  end;
  inherited Dispose(Disposing);
end;

constructor TWinForm.Create;
begin
  inherited Create;
  //
  // Required for Windows Form Designer support
  //
  InitializeComponent;
  //
  // TODO: Add any constructor code after InitializeComponent call
  //
end;

procedure TWinForm.lvRSS_SelectedIndexChanged(sender: System.Object; e: System.EventArgs);
begin

end;

(* _________________________________________________________________________ *)

procedure TWinForm.btnSaveFeed_Click(sender: System.Object; e: System.EventArgs);
begin
  rss.SaveFeed('bug1.xml');
end;

(* _________________________________________________________________________ *)

procedure TWinForm.btnLoadFeed_Click(sender: System.Object; e: System.EventArgs);
begin
  rss := TRSS.Create('bug1.xml');
  _RedrawListView;
end;

(* _________________________________________________________________________ *)


procedure TWinForm.lvRSS_DoubleClick(sender: System.Object; e: System.EventArgs);
var itemNo : Integer;
begin
  with TWFRSSItem.Create do begin
    Text := 'Edit ' + Text;
    formState := stEdit;

    itemNo := lvRSS.SelectedIndices.Item[0];

    thisRSSItem := rss.GetRSSItem( itemNo );

    if ShowDialog = System.Windows.Forms.DialogResult.OK then begin
      rss.UpdateRSSItem(itemNo, thisRSSItem);
    end;
  end;
end;

(* _________________________________________________________________________ *)

procedure TWinForm.btnDeleteItem_Click(sender: System.Object; e: System.EventArgs);
begin
  rss.DeleteRSSItem( lvRSS.SelectedIndices.Item[0]);
  lvRSS.Items [lvRSS.SelectedIndices.Item[0]].Remove;
end;

(* _________________________________________________________________________ *)

procedure TWinForm.btnAddItem_Click(sender: System.Object; e: System.EventArgs);
begin
  with TWFRSSItem.Create do begin
    formState := stAdd;
    if ShowDialog = System.Windows.Forms.DialogResult.OK then begin
      rss.AddRSSItem(thisRSSItem);
      _RedrawListView;
    end;
  end;
end;

(* _________________________________________________________________________ *)

procedure TWinForm._RedrawListView;
var colNo, itemNo : integer;
    rssItem : TRSSItem;
    lvItem : ListViewItem;
begin
  lvRSS.Items.Clear;
  for itemNo := 0 to rss.GetRSSItemCount - 1 do begin
    rssItem :=   rss.GetRSSItem(itemNo);

    lvItem := lvRSS.Items.Add(rssItem.Title);
    lvItem.SubItems.Add(rssItem.PubDate);
  end;

  // Autosize the columns based on their textual content
  for colNo := 0 to lvRSS.Columns.Count - 1 do
    lvRSS.Columns[colNo].Width := -1;
end;

end.
